package com.ruoyi.web.controller.common;

import cn.hutool.core.lang.Snowflake;
import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.enums.ServiceResponseEnum;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.qiniu.QiNiuUploadUtils;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.ImgUpload;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.FileUtils;
import com.ruoyi.common.utils.file.MimeTypeUtils;
import com.ruoyi.common.utils.uuid.Seq;
import com.ruoyi.framework.config.ServerConfig;
import org.apache.commons.io.FilenameUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.InputStream;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * 通用请求处理
 *
 * @author ruoyi
 */
@RestController
@RequestMapping("/common")
public class CommonController {
    private static final Logger log = LoggerFactory.getLogger(CommonController.class);

    @Autowired
    private ServerConfig serverConfig;

    private static final String FILE_DELIMETER = ",";

    @Resource
    private QiNiuUploadUtils qiNiuUploadUtils;

    /**
     * 通用下载请求
     *
     * @param fileName 文件名称
     * @param delete   是否删除
     */
    @GetMapping("/download")
    public void fileDownload(String fileName, Boolean delete, HttpServletResponse response, HttpServletRequest request) {
        try {
            if (!FileUtils.checkAllowDownload(fileName)) {
                throw new Exception(StringUtils.format("文件名称({})非法，不允许下载。 ", fileName));
            }
            String realFileName = System.currentTimeMillis() + fileName.substring(fileName.indexOf("_") + 1);
            String filePath = RuoYiConfig.getDownloadPath() + fileName;

            response.setContentType(MediaType.APPLICATION_OCTET_STREAM_VALUE);
            FileUtils.setAttachmentResponseHeader(response, realFileName);
            FileUtils.writeBytes(filePath, response.getOutputStream());
            if (delete) {
                FileUtils.deleteFile(filePath);
            }
        } catch (Exception e) {
            log.error("下载文件失败", e);
        }
    }

    // /**
    //  * 通用上传请求（本地单个）
    //  */
    // @PostMapping("/upload")
    // public AjaxResult uploadFile(MultipartFile file) throws Exception
    // {
    //     try
    //     {
    //         // 文件上传名称
    //         String fileUploadName = qiNiuUploadUtils.getFileUploadName(file);
    //         // 上传
    //         String url = qiNiuUploadUtils.uploadByte(file.getBytes(), new Snowflake(0, 0).nextIdStr() +"_"+fileUploadName);
    //         if (StringUtils.isBlank(url)){
    //             return AjaxResult.error("上传失败");
    //         }
    //
    //         AjaxResult ajax = AjaxResult.success();
    //         ajax.put("url", url);
    //         ajax.put("fileName", fileUploadName);
    //         ajax.put("newFileName", FileUtils.getName(fileUploadName));
    //         ajax.put("originalFilename", file.getOriginalFilename());
    //         ajax.put("uid", fileUploadName.substring(0, fileUploadName.indexOf(".")));
    //         return ajax;
    //     }
    //     catch (Exception e)
    //     {
    //         return AjaxResult.error(e.getMessage());
    //     }
    // }

    /**
     * 通用上传请求（七牛云单个）
     */
    @PostMapping("/upload")
    public AjaxResult uploadFile(MultipartFile file) throws Exception {
        if (file.isEmpty()) {
            throw new ServiceException(ServiceResponseEnum.UPLOAD_FILE_NOT_NULL);
        }
        String fileName = null;
        try {
            String originalFilename = file.getOriginalFilename();
            if (StringUtils.isNotEmpty(originalFilename)) {
                originalFilename  = originalFilename.substring(0, originalFilename.lastIndexOf("."));
            }
            // 文件名称
            fileName = StringUtils.format("{}/{}/{}_{}/{}.{}", "xxks", DateUtils.datePath(),
                    md5HashCode(file.getInputStream()), Seq.getId(Seq.uploadSeqType), originalFilename, getExtension(file));
            String imagePath = new ImgUpload().upload(file.getBytes(),
                    fileName);
            // String imagePath = new ImgUpload().upload(QiNiuUploadUtils.getZipImage(file),
            //         fileName);
            if (StringUtils.isBlank(imagePath)) {
                return AjaxResult.error("上传失败");
            }
            AjaxResult ajax = AjaxResult.success();
            ajax.put("fileName", fileName);
            ajax.put("url", imagePath);
            return ajax;
        } catch (Exception e) {
            e.printStackTrace();
            return AjaxResult.error(e.getMessage());
        }
    }

    /**
     * java获取文件的md5值
     *
     * @param fis 输入流
     * @return 结果
     */
    public static String md5HashCode(InputStream fis) {
        try {
            //拿到一个MD5转换器,如果想使用SHA-1或SHA-256，则传入SHA-1,SHA-256
            MessageDigest md = MessageDigest.getInstance("MD5");

            //分多次将一个文件读入，对于大型文件而言，比较推荐这种方式，占用内存比较少。
            byte[] buffer = new byte[1024];
            int length = -1;
            while ((length = fis.read(buffer, 0, 1024)) != -1) {
                md.update(buffer, 0, length);
            }
            fis.close();
            //转换并返回包含16个元素字节数组,返回数值范围为-128到127
            byte[] md5Bytes = md.digest();
            BigInteger bigInt = new BigInteger(1, md5Bytes);//1代表绝对值
            return bigInt.toString(16);//转换为16进制
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
    }

    /**
     * 获取文件名的后缀
     *
     * @param file 表单文件
     * @return 后缀名
     */
    public static String getExtension(MultipartFile file) {
        String extension = FilenameUtils.getExtension(file.getOriginalFilename());
        if (org.apache.commons.lang3.StringUtils.isEmpty(extension)) {
            extension = MimeTypeUtils.getExtension(Objects.requireNonNull(file.getContentType()));
        }
        return extension;
    }

    /**
     * 通用上传请求（多个）
     */
    @PostMapping("/uploads")
    public AjaxResult uploadFiles(List<MultipartFile> files) throws Exception {
        try {
            // 上传文件路径
            String filePath = RuoYiConfig.getUploadPath();
            List<String> urls = new ArrayList<String>();
            List<String> fileNames = new ArrayList<String>();
            List<String> newFileNames = new ArrayList<String>();
            List<String> originalFilenames = new ArrayList<String>();
            for (MultipartFile file : files) {
                // 文件上传名称
                String fileUploadName = qiNiuUploadUtils.getFileUploadName(file);
                // 上传（压缩后图片）
                String url = qiNiuUploadUtils.uploadByte(file.getBytes(), new Snowflake(0, 0).nextIdStr() + "_" + fileUploadName);
                if (StringUtils.isBlank(url)) {
                    throw new ServiceException("上传失败");
                }
                urls.add(url);
                fileNames.add(fileUploadName);
                newFileNames.add(FileUtils.getName(fileUploadName));
                originalFilenames.add(file.getOriginalFilename());
            }
            AjaxResult ajax = AjaxResult.success();
            ajax.put("urls", StringUtils.join(urls, FILE_DELIMETER));
            ajax.put("fileNames", StringUtils.join(fileNames, FILE_DELIMETER));
            ajax.put("newFileNames", StringUtils.join(newFileNames, FILE_DELIMETER));
            ajax.put("originalFilenames", StringUtils.join(originalFilenames, FILE_DELIMETER));
            return ajax;
        } catch (Exception e) {
            return AjaxResult.error(e.getMessage());
        }
    }

    /**
     * 本地资源通用下载
     */
    @GetMapping("/download/resource")
    public void resourceDownload(String resource, HttpServletRequest request, HttpServletResponse response)
            throws Exception {
        try {
            if (!FileUtils.checkAllowDownload(resource)) {
                throw new Exception(StringUtils.format("资源文件({})非法，不允许下载。 ", resource));
            }
            // 本地资源路径
            String localPath = RuoYiConfig.getProfile();
            // 数据库资源地址
            String downloadPath = localPath + StringUtils.substringAfter(resource, Constants.RESOURCE_PREFIX);
            // 下载名称
            String downloadName = StringUtils.substringAfterLast(downloadPath, "/");
            response.setContentType(MediaType.APPLICATION_OCTET_STREAM_VALUE);
            FileUtils.setAttachmentResponseHeader(response, downloadName);
            FileUtils.writeBytes(downloadPath, response.getOutputStream());
        } catch (Exception e) {
            log.error("下载文件失败", e);
        }
    }
}
